#include"DS18B20.h"
#include <ioCC2530.h>
#include <string.h>
#include "uart.h"



#define SET_DQ() P1_2 = 1;	 
#define CLR_DQ() P1_2 = 0;	
#define OUT_DQ() P1DIR |= (1<<2); 
#define IN_DQ()  P1DIR &= ~(1<<2);
#define GET_DQ() P1_2


void delay_us (uint16_t timeout) 
{
    while (timeout--)
    {
        asm("NOP");
        asm("NOP");
        asm("NOP");
    }
}

/* Reset */
void resetOnewire(void) 
{
	OUT_DQ(); 
	CLR_DQ();
	delay_us(450);
	SET_DQ();
	delay_us(60);
	IN_DQ();
	delay_us(10);
	while(!(GET_DQ()));
	OUT_DQ();
	SET_DQ();
}

/* Read */
uint8_t rOnewire(void)
{
    uint8_t data=0,i=0;
    for(i=0;i<8;i++)
    {
	    OUT_DQ();
		CLR_DQ();
		data=data>>1;
		SET_DQ();
		IN_DQ()
		delay_us(8);
		if(GET_DQ())data|=0x80;
		OUT_DQ();
		SET_DQ();
		delay_us(60);
    }
    return(data);
}

/* Write */
void wOnewire(uint8_t data)
{
	uint8_t i=0;
	OUT_DQ();
	SET_DQ();
	delay_us(16);
    	for(i=0;i<8;i++)
    	{
		CLR_DQ();
		if(data&0x01)
		{
			SET_DQ();
		}
   	 	else
   	 	{
			CLR_DQ();
    	}
    	data=data>>1;
		delay_us(40);  //65
		SET_DQ();
    }
}
uint8_t* readID(void) 
{ 
    uint8_t ID[8],i,*p;
    resetOnewire(); 
    wOnewire(0x33);
    for(i=0;i<8;i++)
    {ID[i]=rOnewire();}
    p=ID;
    return p;
}

//-----DS18B20ת¶-----
void convertDs18b20(void) 
{ 
    resetOnewire(); 
    wOnewire(0xcc); 
    wOnewire(0x44); 
} 
//------------DS18BB0¶----------
unsigned int readTemp(void) 
{ 
    uint8_t temp1,temp2;
    convertDs18b20();
    resetOnewire(); 
    wOnewire(0xcc); 
    wOnewire(0xbe); 	
    temp1=rOnewire(); 
    temp2=rOnewire(); 
    return (unsigned int)(((temp2<<8)|temp1)*6.25); //0.0625=xx, 0.625=xx.x, 6.25=xx.xx
	
}
