/******************** (C) COPYRIGHT 2012 waveshare ********************
* File Name          : LED.c
* Author             : waveshare.xuwenjie
* Version            : V1.0.0
* Date               : 29/10/2012
* Description        : This file is to realize LED control function
************************************************************************/
#include <ioCC2530.h>
#include"UART.H"
#define LED1 P1_0   
#define LED2 P1_1
#define LED3 P1_4

#define KEY1 P0_1
#define KEY2 P2_0


void GPIO_Init(void)
{
  //LED port config

  P1DIR |= (1<<0) | (1<<1) | (1<<4);              //P1_4 -> output
  
  //KEY port config
  P0SEL &= ~(1<<1);  
  P0DIR &= ~(1<<1);
  P2DIR &= ~(1<<0);
  
  P2SEL &= ~(1<<(0));   //General-purpose I/O
  P2DIR &= ~(1<<(0));  //0 -> INPUT
  P2INP &= ~(1<<(0));  //0 -> Pullup/pulldown
  P2INP |= (1<<7);     //BIT5= 1 -> Pulldown  
  
  LED1 = 0;
  LED2 = 0;
  LED3 = 0;
}


void delay_ms(unsigned int z)
{
  unsigned int x,y;
  for(x=110;x>0;x--)
     for(y=z;y>0;y--);
}
/*******************************************************************************
* Function Name  : SystemInit
* Description    : Initialize the system
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void SystemInit(void)
{
	CLKCONCMD &= ~0x40;               /*Sets the system clock source for 32 MHZ crystal oscillator*/
	while(CLKCONSTA & 0x40);          /* Wait for Oscillator to be ready    */
	CLKCONCMD &= ~0x47;               /*Sets the system master clock frequency for 32 MHZ*/
}


void main(void)
{   
    char key_value = 0;
    SystemInit();
    InitUART(); 
    printf("\r\n HEELO Waveshare\r\n"); 
    GPIO_Init();  
    
    while(1)
    {
      if(KEY1==0)
      {
         delay_ms(10);
         if(KEY1==0)
           key_value = 1;
      }
      if(KEY2==1)
      {
         delay_ms(10);
         if(KEY2==1)
           key_value = 2;
      }
      switch (key_value)
      {
      case 0:
         key_value=0;
          break;
      case 1:
          printf("PRESS KEY1\r\n");
          key_value=0;
          break;
      case 2:
          printf("PRESS KEY2\r\n");
          key_value=0;
          break;
        
      }
    }
}