/******************** (C) COPYRIGHT 2012 waveshare ********************
* File Name          : main.c
* Author             : waveshare.xuwenjie
* Version            : V1.0.0
* Date               : 29/10/2012
* Description        : 
************************************************************************/


#include"AT45DB.h"
#include <iocc2530.h>
#include <string.h>


/*******************************************************************************
* Function Name  : SPI_Configuration
* Description    : None
* Input          : None
* Output         : None
* Return         : None
* Attention	 : None
*******************************************************************************/

void SPI_Configuration(void)
{
/*io initialize*/

   PERCFG |= 0x02;        // PERCFG.U1CFG = 1 
   P1SEL |= 0xE0;         // P1_7, P1_6, and P1_5 are peripherals 
   P1INP &= ~(1<<7);
   
   P0SEL &= ~(1<<4);        // P1_3 is GPIO (SSN) 
   P0DIR |= (1<<4);         // SSN is set as output 
   
/*SPI1 Configuration*/
   
  // Set baud rate to max (system clock frequency / 8) 
  // Assuming a 26 MHz crystal (CC1110Fx/CC2510Fx), 
  // max baud rate = 26 MHz / 8 = 3.25 MHz.  
  U1BAUD = 0x00;   // BAUD_M = 0 
  U1GCR |= 0x11;   // BAUD_E = 1
  
 // SPI Master Mode   
	U1CSR &= ~((1<<7)|(1<<5));//Ϊspiģʽ  Ϊspi
 	U1CSR |= (1<<6);// 
  
    U1GCR |=(1<<7)|(1<<5)|(1<<6);


}
/*******************************************************************************
* Function Name  : SPI1_Send_Data
* Description    : None
* Input          : None
* Output         : None
* Return         : None
* Attention	 : None
*******************************************************************************/
void SPI1_Send_Data(unsigned char tx_data)
{
 	unsigned char rx_data;
	U1DBUF = tx_data; //Ҫ͵
	while(0==(U1CSR&(1<<1)));//ֱ
	U1CSR&=~((1<<1)|(1<<2));//־λ
	rx_data=U1DBUF;


}

/*******************************************************************************
* Function Name  : SPI1_Receive_Data
* Description    : None
* Input          : None
* Output         : None
* Return         : unsigned char rx_data
* Attention	 : None
*******************************************************************************/
unsigned char SPI1_Receive_Data(void)
{
 	unsigned char rx_data;

	U1DBUF=0xff;
	while(0==(U1CSR&(1<<1)));//ֱ
	rx_data=U1DBUF;
	U1CSR&=~((1<<1)|(1<<2));//־λ
 
	 return rx_data;
}
/*******************************************************************************
* Function Name  : AT45DBXX_BUSY
* Description    : None
* Input          : None
* Output         : None
* Return         : None
* Attention	 : None
*******************************************************************************/
void AT45DBXX_BUSY(void)
{
	unsigned char AT45DBXXStruct;
	SSN = 0; 
	SPI1_Send_Data(READ_STATE_REGISTER);
	do
	{AT45DBXXStruct = SPI1_Receive_Data();}
	while(!(AT45DBXXStruct & 0x80));
	SSN = 1; 	
}
/*******************************************************************************
* Function Name  : AT45DBXX_Read_ID
* Description    : None
* Input          : unsigned char *IData
* Output         : None
* Return         : None
* Attention	 : None
*******************************************************************************/
void AT45DBXX_Read_ID(unsigned char *IData)
{
 	unsigned char i;
	
	AT45DBXX_BUSY();
	
	SSN = 0;
	SPI1_Send_Data(Read_ID); //ִжȡid		
  	
  	for(i=0;i<4;i++)
  	{
  		
	 	IData[i] = SPI1_Receive_Data();
  	}
	
	 SSN = 1;  	
}
/*******************************************************************************
* Function Name  : write_buffer
* Description    : None
* Input          : unsigned int BufferOffset,unsigned char Data
* Output         : None
* Return         : None
* Attention	 : None
*******************************************************************************/

void write_buffer(unsigned int BufferOffset,unsigned char Data)
{			
	SSN = 0;
	SPI1_Send_Data(0x84);			
	SPI1_Send_Data(0xff);
	SPI1_Send_Data((unsigned char)BufferOffset>>8);
	SPI1_Send_Data((unsigned char)BufferOffset);		
	SPI1_Send_Data(Data);
	SSN = 1;
}
/*******************************************************************************
* Function Name  : read_buffer
* Description    : None
* Input          : unsigned int BufferOffset
* Output         : None
* Return         : None
* Attention	 : None
*******************************************************************************/

unsigned char read_buffer(unsigned int BufferOffset)
{		
	unsigned char temp=0;

	SSN = 0;
 	SPI1_Send_Data(0xd4);
	SPI1_Send_Data(0xff);
	SPI1_Send_Data((unsigned char)BufferOffset>>8);
	SPI1_Send_Data((unsigned char)BufferOffset);  
	//SPI_Send_byte(0xff);
	SPI1_Send_Data(0xff);	
	temp=SPI1_Receive_Data();
	SSN =1;
	return temp;		
}
