#include "CC2530_GPIO.h"




//dir =0; INPUT
//dir =1; OUTPUT

void GPIO_Init(GPIOSelectType* Px_x,unsigned char GPIO_Mode)
{
  if(Px_x->PORT == 0)
  {
    switch (GPIO_Mode)
    {
      case GPIO_Mode_IPD :    
        if(Px_x->PORT == 0)
        {
          P0SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P0DIR &= ~(1<<(Px_x->PIN));  //0 -> INPUT
          P0INP &= ~(1<<(Px_x->PIN));  //0 -> Pullup/pulldown
          P2INP |= (1<<5);             //BIT5= 1 -> Pulldown              
        }
        else if(Px_x->PORT == 1)
        {
          P1SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P1DIR &= ~(1<<(Px_x->PIN));  //0 -> INPUT
          P1INP &= ~(1<<(Px_x->PIN));  //0 -> Pullup/pulldown
          P2INP |= (1<<(Px_x->PIN));   //1 -> Pulldown           
        }
        else
        {
          P2SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P2DIR &= ~(1<<(Px_x->PIN));  //0 -> INPUT
          P2INP &= ~(1<<(Px_x->PIN));  //0 -> Pullup/pulldown
          P2INP |= (1<<(Px_x->PIN));   //1 -> Pulldown            
        }
        break;
      case GPIO_Mode_IPU :
       if(Px_x->PORT == 0) 
       {
          P0SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P0DIR &= ~(1<<(Px_x->PIN));  //0 -> INPUT
          P0INP &= ~(1<<(Px_x->PIN));  //0 -> Pullup/pulldown
          P2INP &= ~(1<<(Px_x->PIN));   //1 -> Pullup
       }
       else if(Px_x->PORT == 1) 
       {
          P1SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P1DIR &= ~(1<<(Px_x->PIN));  //0 -> INPUT
          P1INP &= ~(1<<(Px_x->PIN));  //0 -> Pullup/pulldown
          P2INP &= ~(1<<(Px_x->PIN));   //1 -> Pullup         
       }
       else
       {
          P2SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P2DIR &= ~(1<<(Px_x->PIN));  //0 -> INPUT
          P2INP &= ~(1<<(Px_x->PIN));  //0 -> Pullup/pulldown
          P2INP &= ~(1<<(Px_x->PIN));   //1 -> drop-U         
       }         
       break;
      case GPIO_Mode_Out_PP :
        if(Px_x->PORT == 0) 
       {
          P0SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P0DIR |=  (1<<(Px_x->PIN));  //1 -> OutPUT
          P0INP &= ~(1<<(Px_x->PIN));  //0 -> Pullup/pulldown
          P2INP &= ~(1<<(Px_x->PIN));   //1 -> drop-UP 
       }
       else if(Px_x->PORT == 1) 
       {
          P1SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P1DIR |=  (1<<(Px_x->PIN));  //1 -> OutPUT
          P1INP &= ~(1<<(Px_x->PIN));  //0 -> Pullup/pulldown
          P2INP &= ~(1<<(Px_x->PIN));   //1 -> drop-UP         
       }
       else
       {
          P2SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P2DIR |=  (1<<(Px_x->PIN));  //0 -> INPUT
          P2INP &= ~(1<<(Px_x->PIN));  //0 -> Pullup/pulldown
          P2INP &= ~(1<<(Px_x->PIN));   //1 -> Pullup         
       }                      
        break;
      case GPIO_Mode_State :
        if(Px_x->PORT == 0)
        {
          P0SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P0INP |=  (1<<(Px_x->PIN));  //1 -> 3 State
        }
       else if(Px_x->PORT == 1) 
       {
          P1SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
          P1INP |=  (1<<(Px_x->PIN));  //1 -> 3 State
       }
       else
       {
         P2SEL &= ~(1<<(Px_x->PIN));   //General-purpose I/O
         P2INP |=  (1<<(Px_x->PIN));  //1 -> 3 State        
       }
      break;                
      default:
      break;
    }    
  } 
}


void GPIO_DIR(GPIOSelectType* Px_x,unsigned char DIR)
{
  if(DIR)
  {
    if(Px_x->PORT == 0)
    {
      P0DIR |= (1<<(Px_x->PIN));
    } 
    else if(Px_x->PORT == 1)
    {
      P1DIR |= (1<<(Px_x->PIN)); 
    } 
    else 
    {
     P2DIR |= (1<<(Px_x->PIN));  
    }
  }
  else
  {
    if(Px_x->PORT == 0)
    {
     P0DIR &= ~(1<<(Px_x->PIN));
    } 
    else if(Px_x->PORT == 1)
    {
      P1DIR &= ~(1<<(Px_x->PIN)); 
    } 
    else
    {
      P1DIR &= ~(1<<(Px_x->PIN)); 
    }     
  }
}

unsigned char GPIO_ReadInputData(GPIOSelectType* Px_x)
{
 
  if(Px_x->PORT == 0)
  {
    if(Px_x->PIN == 0 )
    return P0_0;
    if(Px_x->PIN == 1 )
    return P0_1;
    if(Px_x->PIN == 2 )
    return P0_2;
    if(Px_x->PIN == 3 )
    return P0_3;
    if(Px_x->PIN == 4 )
    return P0_4;
    if(Px_x->PIN == 5 )
    return P0_5;
    if(Px_x->PIN == 6 )
    return P0_6;
    if(Px_x->PIN == 7 )
    return P0_7;
    
  }
  else if(Px_x->PORT == 1)
  {
    if(Px_x->PIN == 0 )
    return P1_0;
    if(Px_x->PIN == 1 )
    return P1_1;
    if(Px_x->PIN == 2 )
    return P1_2;
    if(Px_x->PIN == 3 )
    return P1_3;
    if(Px_x->PIN == 4 )
    return P1_4;
    if(Px_x->PIN == 5 )
    return P1_5;
    if(Px_x->PIN == 6 )
    return P1_6;
    if(Px_x->PIN == 7 )
    return P1_7; 
  } 
  else
  {
    if(Px_x->PIN == 0 )
    return P2_0;
    if(Px_x->PIN == 1 )
    return P2_1;
    if(Px_x->PIN == 2 )
    return P2_2;
    if(Px_x->PIN == 3 )
    return P2_3;
    if(Px_x->PIN == 4 )
    return P2_4;  
  }
}

void GPIO_ResetBits(GPIOSelectType* Px_x)
{
  
  if(Px_x->PORT == 0)
  {
     if(Px_x->PIN == 0 )
     P0_0 = 0;
     if(Px_x->PIN == 1 )
     P0_1 = 0;
     if(Px_x->PIN == 2 )
     P0_2 = 0;
     if(Px_x->PIN == 3 )
     P0_3 = 0;
     if(Px_x->PIN == 4 )
     P0_4 = 0;
     if(Px_x->PIN == 5 )
      P0_5 = 0;
     if(Px_x->PIN == 6 )
       P0_6 = 0;
     if(Px_x->PIN == 7 )
       P0_7 = 0;     
  }
  else if(Px_x->PORT == 1)
  {
     if(Px_x->PIN == 0 )
       P1_0 = 0;
     if(Px_x->PIN == 1 )
       P1_1 = 0;
     if(Px_x->PIN == 2 )
       P1_2 = 0;
     if(Px_x->PIN == 3 )
       P1_3 = 0;
     if(Px_x->PIN == 4 )
       P1_4 = 0;
     if(Px_x->PIN == 5 )
       P1_5 = 0;
     if(Px_x->PIN == 6 )
       P1_6 = 0;
     if(Px_x->PIN == 7 )
       P1_7 = 0; 
  }
  else
  {
      if(Px_x->PIN == 0 )
       P2_0 = 0;
     if(Px_x->PIN == 1 )
       P2_1 = 0;
     if(Px_x->PIN == 2 )
       P2_2 = 0;
     if(Px_x->PIN == 3 )
       P2_3 = 0;
     if(Px_x->PIN == 4 )
       P2_4 = 0; 
  }
}


void GPIO_SetBits(GPIOSelectType* Px_x)
{
  
  if(Px_x->PORT == 0)
  {
     if(Px_x->PIN == 0 )
       P0_0 = 1;
     if(Px_x->PIN == 1 )
       P0_1 = 1;
     if(Px_x->PIN == 2 )
       P0_2 = 1;
     if(Px_x->PIN == 3 )
       P0_3 = 1;
     if(Px_x->PIN == 4 )
       P0_4 = 1;
     if(Px_x->PIN == 5 )
       P0_5 = 1;
     if(Px_x->PIN == 6 )
       P0_6 = 1;
     if(Px_x->PIN == 7 )
       P0_7 = 1;   
  }
  else if(Px_x->PORT == 1)
  {
     if(Px_x->PIN == 0 )
       P1_0 = 1;
     if(Px_x->PIN == 1 )
       P1_1 = 1;
     if(Px_x->PIN == 2 )
       P1_2 = 1;
     if(Px_x->PIN == 3 )
       P1_3 = 1;
     if(Px_x->PIN == 4 )
       P1_4 = 1;
     if(Px_x->PIN == 5 )
       P1_5 = 1;
     if(Px_x->PIN == 6 )
       P1_6 = 1;
     if(Px_x->PIN == 7 )
       P1_7 = 1;  
  }
  else 
  {
     if(Px_x->PIN == 0 )
       P2_0 = 1;
     if(Px_x->PIN == 1 )
       P2_1 = 1;
     if(Px_x->PIN == 2 )
       P2_2 = 1;
     if(Px_x->PIN == 3 )
       P2_3 = 1;
     if(Px_x->PIN == 4 )
       P2_4 = 1;    
  }
}

